unit Unit1;

(*
(c) Keops Août 2014- Domain Public
http://emmanuel.ostenne.free.fr/util.htm#KeopsPolygone
*)

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, Menus, ExtDlgs;

const maxval = 1023;

type

  { TForm1 }

  TForm1 = class(TForm)
    ImageBaseOrg: TImage;
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    OpenPictureDialog1: TOpenPictureDialog;
    PaintBox1: TPaintBox;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    SavePictureDialog1: TSavePictureDialog;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: char);
    procedure FormResize(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure PaintBox1DblClick(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1Paint(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
  private
    { Déclarations privées }
    DBuffImage : TBitmap;
    ImageBase : TBitmap;
    estImageCharge : boolean;
  public
    { Déclarations publiques }
    dessine : boolean ;
    Polygone : array[0..maxval] of TPoint;
    MaxPoints : integer;
    EtatPolygone : integer;
    Etalon : array[0..1] of TPoint;
    EtatEtalon : integer;
    PosEtalon : integer;
    procedure Dessiner;
    procedure GetValeurs(sep : string;var ncote,perimetre,aire : string);
    procedure GetValeurs2(sep : string;var ncote,perimetre,aire,longcote1 : string);
    function getInformations(Sender: TObject) : string;
  end;

var
  Form1: TForm1;

function distance(A,B : TPoint) : double;

implementation

{$R *.lfm}

uses Unit2, Unit3, clipbrd, LCLIntf;

function distance(A,B : TPoint) : double;
               var dx, dy : double;
                begin
                        dx:=A.X-B.X;
                        dy:=A.Y-B.Y;
                        result:=sqrt(dx*dx+dy*dy);
                end;

procedure TForm1.FormCreate(Sender: TObject);
var i : integer;
begin
        dessine:=false;
        estImageCharge:=false;
        MaxPoints:=-1;
        //0 : rien; 1 1er point; 2 fini
        etatPolygone:=0;
        //
        etatEtalon:=0;
        //
        DBuffImage:=TBitmap.create;
        DBuffImage.Width:=Panel2.Width;
        DBuffImage.Height:=Panel2.Height;
        ImageBase:=TBitmap.create;
        ImageBase.Width:=Panel2.Width;
        ImageBase.Height:=Panel2.Height;
        {$IFDEF MSWINDOWS}
        with MainMenu1 do
             for i :=  0 to  Items.Count - 1 do Items[i].Visible := false;
        {$ENDIF}

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     DBuffImage.Free;
     ImageBase.Free;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var s : string;
begin
     //F1
     if (Key=112) then form3.show;
     //CTRL
     if (ssCtrl in Shift) then
        //+V
        if (Key=86) then speedbutton5Click(Sender);
     //s:=inttostr(Key);
     //if ((ssCtrl in Shift)) then Panel4.Caption:=s;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: char);
begin
     if key=chr(27) then begin
         If SpeedButton2.Down then begin
             SpeedButton2.Down:=false;
             SpeedButton2Click(Sender);
         end;
         If SpeedButton3.Down then begin
             SpeedButton3.Down:=false;
             SpeedButton3Click(Sender);
         end;
     end;
end;


procedure TForm1.FormResize(Sender: TObject);
begin
     DBuffImage.width:=Panel2.width;
     DBuffImage.height:=Panel2.height;
end;

procedure TForm1.MenuItem5Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.PaintBox1DblClick(Sender: TObject);
begin
     if not dessine then exit;
     if speedButton2.down then begin
         If SpeedButton2.Down then begin
             SpeedButton2.Down:=false;
             SpeedButton2Click(Sender);
         end;
     end;
end;


procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
      if not(button in [mbLeft]) then exit;
      if speedButton2.down then begin
              if etatPolygone=0 then begin
                      MaxPoints:=0;
                      etatPolygone:=1;
              end;
              if MaxPoints<MaxVal then begin
                  Polygone[MaxPoints].X:=X;
                  Polygone[MaxPoints].Y:=Y;
                  inc(MaxPoints);
              end;
              dessine:=true;
      end;
      if speedButton3.down then begin
                inc(EtatEtalon);
                if odd(etatEtalon) then begin
                        Etalon[0].X:=X;
                        Etalon[0].Y:=Y;
                end;
                Etalon[1].X:=X;
                Etalon[1].Y:=Y;
                dessine:=true;
      end;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
      if not dessine then exit;
      if speedButton2.down then begin
              if etatPolygone=1 then begin
                      Polygone[MaxPoints].X:=X;
                      Polygone[MaxPoints].Y:=Y;
                      Dessiner;
              end;
      end;
      if speedButton3.down then begin
                if odd(etatEtalon) then begin
                      Etalon[1].X:=X;
                      Etalon[1].Y:=Y;
                      Dessiner;
                end;
      end;
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
      if not(button in [mbLeft]) then exit;
      if not dessine then exit;
        if speedButton3.Down then begin
                inc(etatEtalon);
        end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
         Dessiner;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
        if SpeedButton2.Down or SpeedButton3.Down then exit;
        if OpenPictureDialog1.execute then begin
              try
                ImageBaseOrg.Picture.LoadFromFile(OpenPictureDialog1.FileName);
                ImageBase.canvas.draw(0,0,ImageBaseOrg.picture.graphic);
              except
                //on EInvalidGraphic do ShowMessage('Format image non supporté ou le fichier n''est pas une image !') ;
              end;
              estImageCharge:=true;
              Dessiner;
        end;
        SpeedButton1.Down:=false;
        Panel4.Caption:='Image insérée : Polygone, puis Etalonnage, puis Calculs';
end;


procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
        if SpeedButton2.Down then begin
                etatPolygone:=0;
                MaxPoints:=-1;
                PaintBox1.Refresh;
                Panel4.Caption:='Tracer puis cliquer sur [Polygone] ou [Etalonnage] ou Echap pour clore le polygone';
        end else begin
                if etatPolygone=1 then begin
                        dec(MaxPoints);
                        etatPolygone:=2;
                        PaintBox1.Refresh;
                        Panel4.Caption:='';
                end
        end;
end;


procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
        if SpeedButton3.Down then begin
                Panel4.Caption:='Tracer un segment pour une longueur connue puis recliquer sur [Etalonnage] ou Echap.';
                if etatPolygone=1 then begin
                        dec(MaxPoints);
                        etatPolygone:=2;
                end;
                etatEtalon:=0;
                posEtalon:=0;
                PaintBox1.Refresh;
        end else begin
                etatEtalon:=2;
                PaintBox1.Refresh;
                dessine:=false;
                if distance(Form1.Etalon[0],Form1.Etalon[1])<1 then begin
                          showMessage('Attention, le segment tracé est trop petit.');
                 end;
                Panel4.Caption:='';
        end;

end;

procedure TForm1.GetValeurs(sep : string;var ncote,perimetre,aire : string);

        function AirePolygone(Points : Array of TPoint; NPoints : integer) : double;
	var dx : Array [0..maxval] of double;
	    dy : Array [0..maxval] of double;
	    aire : double;
	    i,j : integer;
        begin
                aire:=0;
                j:=NPoints-1;
        	for i:=0 to NPoints-1 do begin
                        dx[i] := (Points[j].x-Points[i].x)/2;
        		dy[i] := (Points[j].y-Points[i].y)/2;
        		j:=i;
        	end;
        	for i:=0 to NPoints-1 do begin
        	        aire := aire + (Points[i].x*dy[i]-Points[i].y*dx[i]);
                end;
        	result:=abs(aire);
        end;

        function LongueurPolygone(Points : Array of TPoint; NPoints : integer) : double;
        var
            longueur : double;
            i,j : integer;
        begin
             longueur:=0;
             j:=NPoints-1;
             for i:=0 to NPoints-1 do begin
                 longueur:=longueur+distance(Points[i],Points[j]);
                 j:=i;
             end;
             result:=longueur;
        end;

        function aireEtalon(Points : Array of TPoint) : double;
                var dx, dy : double;
        begin
                dx:=Points[0].X-Points[1].X;
                dy:=Points[0].Y-Points[1].Y;
                result:=dx*dx+dy*dy;
        end;

        var
            airec,
            aireReelle,
            longueur,
            dim_reelle,
            dim_etalon_carre : double;
begin
     dim_etalon_carre:=aireEtalon(Etalon);
     airec:=AirePolygone(Polygone,MaxPoints+1);
     dim_reelle:=strToFloat(Form2.Edit1.Text);

     aireReelle:=dim_Reelle*dim_Reelle/dim_etalon_carre;
     airec:=airec*aireReelle;
     airec:=int(airec*100)/100;
     longueur:=LongueurPolygone(Polygone,MaxPoints);
     longueur:=Longueur*dim_reelle/sqrt(dim_etalon_carre);
     longueur:=int(longueur*100)/100;
     ncote:=inttostr(MaxPoints+1);
     aire:=FloatToStr(airec)+sep+Form2.ComboBox1.Items[Form2.ComboBox1.ItemIndex]+'²';
     perimetre:=FloatToStr(longueur)+sep+Form2.ComboBox1.Items[Form2.ComboBox1.ItemIndex];
end;

procedure TForm1.GetValeurs2(sep : string;var ncote,perimetre,aire,longcote1 : string);

        function AirePolygone(Points : Array of TPoint; NPoints : integer) : double;
	var dx : Array [0..maxval] of double;
	    dy : Array [0..maxval] of double;
	    aire : double;
	    i,j : integer;
        begin
                aire:=0;
                j:=NPoints-1;
        	for i:=0 to NPoints-1 do begin
                        dx[i] := (Points[j].x-Points[i].x)/2;
        		dy[i] := (Points[j].y-Points[i].y)/2;
        		j:=i;
        	end;
        	for i:=0 to NPoints-1 do begin
        	        aire := aire + (Points[i].x*dy[i]-Points[i].y*dx[i]);
                end;
        	result:=abs(aire);
        end;

        function LongueurPolygone(Points : Array of TPoint; NPoints : integer) : double;
        var
            longueur : double;
            i,j : integer;
        begin
             longueur:=0;
             j:=NPoints-1;
             for i:=0 to NPoints-1 do begin
                 longueur:=longueur+distance(Points[i],Points[j]);
                 j:=i;
             end;
             result:=longueur;
        end;

        function LongueurCote1(Points : Array of TPoint) : double;
        var
            longueur : double;
            //i,j : integer;
        begin
             longueur:=distance(Points[0],Points[1]);
             result:=longueur;
        end;

        function aireEtalon(Points : Array of TPoint) : double;
                var dx, dy : double;
        begin
                dx:=Points[0].X-Points[1].X;
                dy:=Points[0].Y-Points[1].Y;
                result:=dx*dx+dy*dy;
        end;

        var
            airec,
            aireReelle,
            longueur,
            cote1c,
            dim_reelle,
            dim_etalon_carre : double;
begin
     dim_etalon_carre:=aireEtalon(Etalon);
     airec:=AirePolygone(Polygone,MaxPoints+1);
     dim_reelle:=strToFloat(Form2.Edit1.Text);

     aireReelle:=dim_Reelle*dim_Reelle/dim_etalon_carre;
     airec:=airec*aireReelle;
     airec:=int(airec*100)/100;

     longueur:=LongueurPolygone(Polygone,MaxPoints);
     longueur:=Longueur*dim_reelle/sqrt(dim_etalon_carre);
     longueur:=int(longueur*100)/100;

     ncote:=inttostr(MaxPoints+1);

     cote1c:=LongueurCote1(Polygone);
     cote1c:=cote1c*dim_reelle/sqrt(dim_etalon_carre);
     cote1c:=int(cote1c*100)/100;

     aire:=FloatToStr(airec)+sep+Form2.ComboBox1.Items[Form2.ComboBox1.ItemIndex]+'²';
     perimetre:=FloatToStr(longueur)+sep+Form2.ComboBox1.Items[Form2.ComboBox1.ItemIndex];
     longcote1:=FloatToStr(cote1c)+sep+Form2.ComboBox1.Items[Form2.ComboBox1.ItemIndex];
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
        if SpeedButton3.Down then begin
           SpeedButton3.Down:=false;
           SpeedButton3Click(Sender);
        end;
        if SpeedButton2.Down then begin
           speedButton4.down:=false;
           exit;
        end;
        //
        if (EtatPolygone=0) or (etatEtalon=0) then begin
              showMessage('Il faut tracer le polygone ET étalonner l''unité de mesure');
        end else begin
                Panel4.Caption:='Compléter la longueur réelle du segment bleu et valider';
                Form2.showModal;
                Panel4.Caption:='';
        end;
        speedButton4.down:=false;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
        if SpeedButton2.Down or SpeedButton3.Down then exit;
        if Clipboard.HasFormat(CF_PICTURE) then begin
            //ImageBaseOrg.Picture.Bitmap.Assign(Clipboard);
            ImageBaseOrg.Picture.Assign(Clipboard);
            estImageCharge:=true;
            Panel4.Caption:='Image insérée : Polygone, puis Etalonnage, puis Calculs';
            Dessiner;
        end;
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
     //Form3.showModal;
     OpenDocument('airePolygone.htm');
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
var
    MonBitmap : TBitmap;
    OrgRect : TRect;
    png : TPortableNetworkGraphic;
    textFile : TStringList;
begin
      //sauve l'image et un fichier data avec l'extension de l'image, le polygone, l'étalon et la mesure réelle
      //extension .txt qui sera lisible par Ouvrir mais pas coller.
      //Ajouter Drag/Drop ?
     if not estImageCharge then exit;
     If SavePictureDialog1.Execute then begin
          OrgRect.left:=0;
          OrgRect.top:=0;
          OrgRect.Right:=ImageBaseOrg.Picture.width;
          OrgRect.Bottom:=ImageBaseOrg.Picture.height;
          try
          MonBitmap:=TBitmap.create;
          MonBitmap.Width:=OrgRect.Right;
          MonBitmap.Height:=OrgRect.Bottom;
          MonBitmap.Canvas.CopyRect(OrgRect,DBuffImage.Canvas,OrgRect);
          //MonBitmap.SaveToFile(SavePictureDialog1.FileName);
          png := TPortableNetworkGraphic.Create;
          try
             png.Assign(MonBitmap);
             png.SaveToFile(SavePictureDialog1.FileName);
          finally
             png.Free;
          end;
          finally
             MonBitmap.Free;
          end;
          textFile:=TStringList.create();
          try
             textFile.text:=getInformations(Sender);
             textFile.SaveToFile(changeFileExt(SavePictureDialog1.FileName,'.txt'));
          finally
             textFile.Free;
          end;
     end;
end;

procedure TForm1.Dessiner;
begin
        with DBuffImage.Canvas do begin
             Brush.Color:=clBtnFace;
             Brush.Style:=bsSolid;
             FillRect(PaintBox1.CLientRect);
             draw(0,0,ImageBaseOrg.Picture.graphic);
        end;
        if MaxPoints>-1 then begin
                With DBuffImage do begin
                        Canvas.Pen.Width:=2;
                        Canvas.Pen.Color:=clRed;
                        Canvas.Brush.Color:=$004080FF;
                        Canvas.Brush.Style:=bsDiagCross;
                        Canvas.Polygon(Slice(Polygone,MaxPoints+1));
                end;
        end;
        if etatEtalon>0 then begin
                With DBuffImage do begin
                        Canvas.Pen.Color:=clBlue;
                        Canvas.Pen.Width:=2;
                        Canvas.PolyLine(Etalon);
                end;
        end;
        PaintBox1.Canvas.draw(0,0,DBuffImage);
end;

function TForm1.getInformations(Sender: TObject) : string;
var
   ncote,perimetre,aire,longcote : string;
   up,ua : string;
   vp,va : string;
   s : string;
   CRLF : string;
   Sep : string;
   p :integer;
begin
       if (EtatPolygone=0) or (etatEtalon=0) then begin
          s:='non calculé';
       end else begin
             CRLF:=chr(13)+chr(10);
             Sep:=chr(9);
             //GetValeurs(ncote,perimetre,aire);
             GetValeurs2(sep,ncote,perimetre,aire,longcote);
             //
             p:=pos(' ',perimetre);
             vp:=copy(perimetre,1,pos(' ',perimetre)-1);
             up:=copy(perimetre,p+1, length(perimetre)-p);
             p:=pos(' ',aire);
             va:=copy(aire,1,pos(' ',aire)-1);
             ua:=copy(aire,p+1, length(aire)-p);
             //
             s:='côtés'+Sep+ncote+CRLF+
             'longueur 1er côté'+Sep+longcote+CRLF+
             'périmètre'+Sep+vp+Sep+up+CRLF+
             'aire'+Sep+va+Sep+ua+CRLF;
       end;
       result:=s;
end;

end.

